.model small
.stack 100h
.data
	info db "Programos autorius: Heroix",10,13,"Programa atspausdina skaitmenu kieki ivestoje simboliu eiluteje.",10,13,10,13,"$"
	askToWrite db "Iveskite simboliu eilute:",10,13,"$"
	showResult db 10,13,"Simboliu eiluteje buvo skaiciu:",10,13,"$"
	showError db 10,13,"Ivedete tuscia eilute. Iveskite isnaujo: ",10,13,"$"
	
	stringMax db 100			;maximum galima nuskaityt simboliu
	stringSize db ?				;nuskaityta simboliu
	string db 100 dup (?)		;eilute
	
.code
program:
		MOV ax, @data
		MOV ds, ax
	
		MOV ch, 0
		MOV cl, [es:80h]		;programos paleidimo simbolio skicius 128-ame (80h) baite
		CMP cx, 0				;jei paleidimo nera
		JE	startProgram
		MOV bx, 81h			;programos paleidimo parametrai rodomi segmente es pradedant 129 (81h) baitu
		
	searchParameter:
		CMP [es:bx], '?/'
		JE	showInfo			;Jei yra parametras /? rodo info
		INC	bx
		LOOP searchParameter
		
		JMP startProgram		;o poto pradeda programa, nesvarbu /? randa ar ne
		
	showInfo:
		MOV ah,9
		MOV dx, offset info
		INT 21h
		JMP endProgram
		
	startProgram:
		MOV ah,9				
		MOV dx, offset askToWrite
		INT 21h
	
	readString:
		MOV	ah, 0Ah
		MOV	dx, offset stringMax
		INT	21h					;nuskaitoma ivesta eilute
		
		CMP stringSize, 0		;tikrina ar eilute netuscia
		JE showStringError
				
		MOV ch, stringSize		;ch - dabar rodys kiek simboliu liko perziureti
		MOV bx, offset string;Size
		MOV cl, 0
		
		MOV	dl, '0'
		MOV	dh, '9'
	checking:
		CMP [ds:bx], dl
		JB continueChecking
		CMP [ds:bx], dh
		JA continueChecking
		INC cl					;jei randa skaiciu padidina ch vienetu
		
	continueChecking:
		INC bx					;skaito sekanti simboli
		DEC ch					;sumazina kiek liko perziureti
		CMP ch, 0
		JNE checking			;tesia cikla, jei dar liko simboliu
				
		MOV	ah, 9
		MOV dx, offset showResult
		INT	21h
		
	showCount:
		MOV ax,cx			;prisilyginam ax=cx=(kiek skaitmenu buvo eilutej), riek nes ax galima dalint (DIV)
		
		MOV	cx, 10			;dalinsim is 10
		PUSH "$"			;i stecko pradzia (skaitant bus pabaiga) idedam simbolius zymincius pabaiga
		
		Divide:
			MOV	dx, 0		;isvalom registra, nes jis dalyvaus dalyboje
			DIV	cx			;[DX,AX]:10 = AX (liekana DX)
			PUSH dx			;idedam liekana (paskutini skaiciaus skaitmeni) i stecka
			CMP	ax, 0		;tikrina ar dar yra liekana (ar dar nepeskaitytas visas skaicius)
			JA	Divide		;jei ne, skaitom toliau

		Print:
			MOV	ah, 2		;spausdina po 1 char
			POP	dx			;isimamas 1 skaitmuo is stecko
			CMP	dx, "$"		;tikrina ar baigesi stecko eilute
			JE	endProgram
			ADD	dl, '0'		;liekanos jaunesnysis baitas - tai vienas skaitmuo; prideje simbolini 0 is skaiciaus (pvz.: 1) gausime simboli ('1')
			INT	21h			;spausdina skaitmeni
			JMP	Print
		
	endProgram:
		MOV ah, 4Ch
		MOV al, 0
		INT 21h
		
	showStringError:
		MOV ah,9
		MOV dx, offset showError
		INT 21h
		JMP readString

END program
